
#pragma hdrstop

#include "ClientConn.h"
#include "../Common/Command.h"

CClientConnection::CClientConnection(unsigned uiTimeout)
{
  m_uiTimeout = uiTimeout;
  m_fSession = false;
}

CClientConnection::~CClientConnection()
{
}

int CClientConnection::OpenSession(void)
{
  if(m_fSession)
    DisconnectServer();
  if(!ConnectServer())
    return CMD_ERR_CONNECT;
  return CMD_SUCCESS;
}

int CClientConnection::SessionCmd(CCommand *cCmd, unsigned uiAddTimeout)
{
  if(!m_fSession)
    return CMD_ERR_NOSESSION;
  cCmd->Set(cCmd->Status() & CMD_COUNTER_MASK);
  if(!Write(cCmd))
    return CMD_ERR_WRITE;
  if(!Wait(m_uiTimeout + uiAddTimeout))
    return CMD_ERR_TIMEOUT;
  if(!Read(cCmd))
    return CMD_ERR_READ;
  return CMD_SUCCESS;
}

int CClientConnection::CloseSession(void)
{
  if(!m_fSession)
    return CMD_ERR_NOSESSION;
  DisconnectServer();
  return CMD_SUCCESS;
}

int CClientConnection::Process(CCommand *cCmd, unsigned uiAddTimeout)
{
  if(!ConnectServer())
    return CMD_ERR_CONNECT;
  cCmd->Set(cCmd->Status() & CMD_COUNTER_MASK);
  if(!Write(cCmd))
    return CMD_ERR_WRITE;
  if(!Wait(m_uiTimeout + uiAddTimeout))
    return CMD_ERR_TIMEOUT;
  if(!Read(cCmd))
    return CMD_ERR_READ;
  DisconnectServer();
  return CMD_SUCCESS;
}
