#define _CRT_SECURE_NO_WARNINGS
#include <windows.h>

#pragma hdrstop

#include "ClientMsg.h"
#include "../Common/Const.h"
#include "../Common/Command.h"
#include "../Common/UtilClass.h"

CClientMsg::CClientMsg(const char *pszServerWnd) : CClientConnection(5000), CMsgEndpoint(NULL, NULL)
{
  m_hServerWnd = NULL;
  m_pszServerWnd = new char [strlen(pszServerWnd) + 1];
  strcpy(m_pszServerWnd, pszServerWnd);
}

CClientMsg::~CClientMsg()
{
  delete [] m_pszServerWnd;
}

bool CClientMsg::ConnectServer(void)
{
  m_hServerWnd = FindWindowEx(HWND_MESSAGE, NULL, MSG_SERVER_WND_CLASS, m_pszServerWnd);
  return m_hServerWnd != NULL;
}

void CClientMsg::DisconnectServer(void)
{
  m_hServerWnd = NULL;
}

bool CClientMsg::Write(const CCommand *cCmd)
{
  CMsgData *cSendCmd;
  RMsgData rMsgData;
  bool fResult;

  rMsgData.m_hWnd = m_hServerWnd;
  rMsgData.m_dwId = cCmd->Get();
  cSendCmd = new CMsgData(rMsgData, cCmd->DataPointer(), cCmd->DataLen());
  fResult = Send(cSendCmd);
  delete cSendCmd;
  return fResult;
}

bool CClientMsg::Wait(unsigned uiTimeout)
{
  return WaitForSingleObject(ReceivedEvent(), uiTimeout) == WAIT_OBJECT_0;
}

bool CClientMsg::Read(CCommand *cCmd)
{
  CMsgData *cRcvMsg;
  bool fResult;

  cRcvMsg = new CMsgData();
  fResult = Get(cRcvMsg); // zskn dat
  if(fResult)
    cCmd->Set((unsigned)cRcvMsg->Get().m_dwId, cRcvMsg->DataPointer(), cRcvMsg->DataLen());
  delete cRcvMsg;  
  return fResult;
}
