#ifndef _CLIENTMSG_H
#define _CLIENTMSG_H

#include <windows.h>
#include "ClientConn.h"
#include "..\Common\MsgEndpoint.h"

/*!
@file ClientMsg.h
Deklarace tdy @ref CClientMsg.
*/

//! klientsk st pro komunikaci pomoc zprv
/*!
Realizace klientsk sti komunikace pomoc penosu Windows zprv mezi dvma okny. Implementuje 
ist virtuln metody @ref CClientConnection, funkcionalitu pro obsluhu zprv dd od
@ref CMsgEndpoint. Nedeklaruje dn nov veejn metody.
@warning Tda nen bezpen pi souasnm voln metody @ref CClientMsg::Process z vce vlken pro
tut instanci. V takovm ppad me dojt k tomu, e dojde k vbru zprvy s odpovd, kter
neodpovd dotazu. Pokud by uivatel poteboval souasn volat odesln/pjem pkaz z vce vlken, je
poteba v kadm z nich vytvoit vlastn instanci tdy. Kad z nich bude mt sv okno a vlastn pracovn 
vlkno a navzjem se nebudou nijak ovlivovat.
*/
class CClientMsg : public CClientConnection, private CMsgEndpoint {
public:
  //! konstruktor
  /*! 
  Nepotebuje dn rozeznateln jmno a tdu pro sv intern komunikan okno.
  Server zskv pslun handle pmo z obdren zprvy a klient je tm, kdo komunikaci vdy zahajuje.
  @param[in] pszServerWnd jmno okna na stran serveru, se kterm se klient pokou spojit
  */
  CClientMsg(const char *pszServerWnd);
  //! destruktor
  virtual ~CClientMsg();
protected:
  virtual bool ConnectServer(void);
  virtual void DisconnectServer(void);
  virtual bool Write(const CCommand *cCmd);
  virtual bool Wait(unsigned uiTimeout);
  virtual bool Read(CCommand *cCmd);
private:
  HWND m_hServerWnd;
  char *m_pszServerWnd;
};

#endif
