#include <winsock2.h> // mus bt ped <windows.h>
#include <windows.h>

#pragma hdrstop

#include "ClientTcp.h"
#include "../Common/Command.h"

CClientTcp::CClientTcp(const char *pszServer) : CClientConnection(5000), CSocketEndpoint(pszServer)
{
}

CClientTcp::~CClientTcp()
{
}

bool CClientTcp::ConnectServer(void)
{
  sockaddr_in rMyAddress;
  bool fConnected;

  fConnected = false;
  OpenSocket();
  if(Valid()) {
    Address(&rMyAddress);
    if(connect(Socket(), (const sockaddr *)&rMyAddress, sizeof(sockaddr_in)) != SOCKET_ERROR)
      fConnected = true;
  }
  return fConnected;
}

void CClientTcp::DisconnectServer(void)
{
  CloseSocket();
}

bool CClientTcp::Write(const CCommand *cCmd)
{
  bool fResult;
  unsigned uiAux;

  if(!Valid())
    return false;
  uiAux = cCmd->Status();
  fResult = Send((const char *)&uiAux, sizeof(unsigned)) == sizeof(unsigned); // id
  uiAux = cCmd->DataLen();
  fResult = fResult && Send((const char *)&uiAux, sizeof(unsigned)) == sizeof(unsigned); // dlka dat
  fResult = fResult && Send((const char *)cCmd->DataPointer(), uiAux) == uiAux; // data
  return fResult;
}

bool CClientTcp::Wait(unsigned uiTimeout)
{
  timeval rTimeout;
  fd_set rReadSet;

  if(!Valid())
    return false;
  rTimeout.tv_sec = uiTimeout / 1000;
  rTimeout.tv_usec = (uiTimeout % 1000) * 1000;
  FD_ZERO(&rReadSet);
  FD_SET(Socket(), &rReadSet);
  return select(0, &rReadSet, NULL, NULL, &rTimeout) == 1;
}

bool CClientTcp::Read(CCommand *cCmd)
{
  BYTE *pbData;
  unsigned uiStatus;
  unsigned uiLength;
  bool fResult;

  if(!Valid())
    return false;
  pbData = NULL;
  fResult = Receive((char *)&uiStatus, sizeof(unsigned)) == sizeof(unsigned);
  fResult = fResult && Receive((char *)&uiLength, sizeof(unsigned)) == sizeof(unsigned);
  if(fResult && uiLength != 0) {
    pbData = new BYTE [uiLength];
    fResult = fResult && Receive((char *)pbData, uiLength) == uiLength;
  }
  if(fResult)
    cCmd->Set(uiStatus, pbData, uiLength);
  delete [] pbData;
  return fResult;
}
