#ifndef _CLIENTTCP_H
#define _CLIENTTCP_H

#include "ClientConn.h"
#include "..\Common\SocketEndpoint.h"

/*!
@file ClientTcp.h
Deklarace tdy @ref CClientTcp.
*/

//! klientsk st pro komunikaci pomoc TCP protokolu
/*!
Realizace klientsk sti komunikace pomoc penosu soket po protokolu TCP. Klient pedpokld krom
penosu binrnch dat i penos stavovho slova, formt zprvy je nsledujc:
@li <em>stavov slovo</em> typu <tt>unsigned int</tt> ve formtu little-endian,
@li <em>velikost pole dat</em> typu <tt>unsigned int</tt> ve formtu little-endian,
@li <em>data</em> v binrnm formtu.

Implementuje ist virtuln metody @ref CClientConnection, zkladn funkcionalitu pro prci se sokety
dd od @ref CSocketEndpoint. Nedeklaruje dn nov veejn metody.
*/
class CClientTcp : public CClientConnection, private CSocketEndpoint {
public:
  //! konstruktor
  /*!
  @param[in] pszServer umstn serveru (IP adresa a port)
  @n Podporovan formty jsou popsny u konstruktoru @ref CSocketEndpoint::CSocketEndpoint.
  */
  CClientTcp(const char *pszServer);
  //! destruktor
  virtual ~CClientTcp();
protected:
  virtual bool ConnectServer(void);
  virtual void DisconnectServer(void);
  virtual bool Write(const CCommand *cCmd);
  virtual bool Wait(unsigned uiTimeout);
  virtual bool Read(CCommand *cCmd);
};

#endif
