#ifndef _SERVERQUERY_H
#define _SERVERQUERY_H

#include "../Common/UtilClass.h"
#include "../Common/Query.h"

/*!
@file ServerQuery.h
Implementace tdy @ref CServerQuery, kter na stran serveru zajiuje sprvn pevod binrnch
dat z meziprocesov komunikace na voln databzovho rozhran @ref CQuery.
*/

//! pevod binrnch dat na dotaz do databze
/*!
Tda zabezpeuje dekdovn binrnch dat pijatch pomoc meziprocesov komunikace 
(pipravench pomoc tdy @ref CClientQuery) a jejich pevod
do voln metody databzovho rozhran @ref CQuery. Nvratovou hodnotu a hodnoty vstupnch
parametr pak nsledn pevede do tvaru vhodnho k transportu zpt k volajcmu klientovi.
Problematika je zevrubnji popsna na stnce @ref ipc.
*/
class CServerQuery {
public:
  //! konstruktor
  /*!
  Vytvoen instance tdy a piazen rozhran pro voln dotaz do databze.
  @param[in] cQuery instance databze
  */
  CServerQuery(CQuery *cQuery);
  //! destruktor
  ~CServerQuery();
  //! metoda pro dotazovn se databzovho rozhran
  /*!
  Statick metoda, kter je volna jako funkce z @ref CServerConnection pro vykonn databzovho 
  dotazu.
  @param[in] pParam ukazatel na instanci tdy (pro zjitn intern uloenho ukazatele na
  instanci databze),
  @param[in, out] cBlob binrn data dotazu a nvratov hodnoty po jeho vykonn
  */
  static unsigned ServerCall(void *pParam, CBlob *cBlob);
private:
  CQuery *m_cQuery;
};

#endif
